/* -*- MaTX -*-
 *
 * tmd00016.h: TMD No. tmd00016 ư֥󥸥Τε۵ϤΥǥ
 *                               إåե
 *
 *  Originally written by KIYOTA Hiromitsu <1999/02/18>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00016.h,v 1.4 1999/05/31 03:42:36 kiyota Exp $
 */

#ifndef _TMD00016_H
#define _TMD00016_H

#ifdef TMD_USER_H
#include TMD_USER_H
#endif /* TMD_USER_H */

#ifdef TMD00016_USER_H
#include TMD00016_USER_H
#endif /* TMD00016_USER_H */

#ifndef TMD00016_MM
#define TMD00016_MM "tmd00016.mm"
#endif /* !TMD00016_MM */

#ifdef TMD_ENABLE_PACKAGE
#ifdef TMD_ANSI
#define tmd00016(var) _tmd00016_ ## var
#else /* ! TMD_ANSI */
#define tmd00016(var) _tmd00016_/**/var
#endif /* TMD_ANSI */
#else /* ! TMD_ENABLE_PACKAGE */
#define tmd00016(var) var
#endif /* TMD_ENABLE_PACKAGE */

#ifndef TMD_EXTERN
#define TMD_EXTERN
#endif /* ! TMD_EXTERN */

// ǥξ(x)(u)(y)μο
#define TMD00016_DIM_STATE 1
#define TMD00016_DIM_INPUT 2
#define TMD00016_DIM_OUTPUT 1
#define TMD00016_DIM_ALL_IOS (TMD00016_DIM_INPUT+TMD00016_DIM_OUTPUT)

// ǥξ֡ξ֡ϤڤФԤʤޥ(ؿ)
#define chop_state_tmd00016(xx) [xx(1:TMD00016_DIM_STATE)]
#define chop_other_state_tmd00016(xx) [xx(TMD00016_DIM_STATE+1:)]
#define chop_input_tmd00016(uu) [uu(1:TMD00016_DIM_INPUT)]

// ǥ(ʪ)ѥ᡼
TMD_EXTERN Real tmd00016(P0), tmd00016(T0), tmd00016(Tm), tmd00016(At0);
TMD_EXTERN Real tmd00016(Vm), tmd00016(Vc), tmd00016(R), tmd00016(kappa);
TMD_EXTERN Real tmd00016(a0), tmd00016(a1), tmd00016(a2), tmd00016(a3);

// ѥåե饰: 1 ǥ; 0 ǥȤ
#ifdef TMD_DISABLE_HALIST
#define TMD00016_DISABLE_HALIST
#endif /* TMD_DISABLE_HALIST */
#ifdef TMD00016_DISABLE_HALIST
TMD_EXTERN Integer tmd00016_flag;
#endif /* TMD00016_DISABLE_HALIST */

// ؿ
#if !defined(TMD_USER_MM) && !defined(TMD00016_USER_MM) || !defined(TMD_DIVIDED_COMPILE) && !defined(TMD00016_DIVIDED_COMPILE)
#include TMD00016_MM
#else /* !(!TMD_USER_MM && !TMD00016_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00016_DIVIDED_COMPILE) */
void init_tmd00016(/* linear_flag, params_flag, */ ...); // require TMD00016_MM;
Matrix diff_tmd00016(/* t, x, u */); // require TMD00016_MM;
Matrix output_tmd00016(/* t, x, u */); // require TMD00016_MM;
#endif /* !TMD_USER_MM && !TMD00016_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00016_DIVIDED_COMPILE */

#undef TMD_EXTERN
#endif /* ! _TMD00016_H */
